#ifndef __OGL_SYSTEM_H
#define __OGL_SYSTEM_H

#include <GL/glut.h>            // use glut for now
#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glx.h>             // not yet used
#include <X11/Xlib.h>
#include <time.h>               // fps timer

#define WIN_X_DEFAULT 640
#define WIN_Y_DEFAULT 480

class OGL_System {
private:
    int frames;
    time_t start_time, end_time;

    /* font variables */
    Display *disp;
    int FontList;
    XFontStruct *FontInfo;
    float fr, fg, fb;
protected:
    int ScreenX, ScreenY;
public:
    OGL_System(int *argc, char *argv[],
               void (*displayf)(), void (*scenariof)(),
               void (*mousef)(int,int,int,int),
               void (*nkeyf)(unsigned char,int,int), void (*skeyf)(int,int,int),
               char *win_name="", int X=WIN_X_DEFAULT, int Y=WIN_Y_DEFAULT);
    ~OGL_System();

    void Restart_FPS_Timer();
    void Increment_Frame_Counter();
    float Get_FPS();

    void Load_Font(char *fnt);
    void Set_Font_Color(float r, float g, float b);
    void Print(float x, float y, char *s);

    friend void ResizeHandler(int new_width, int new_height);
};

void ResizeHandler(int new_width, int new_height);

#endif
