#ifndef __TEXTURE_H
#define __TEXTURE_H

#include <GL/gl.h>
#include <GL/glu.h>
#include <X11/Xlib.h>
#include <Imlib.h>

/* for alpha parameter in Load() method */
#define NO_ALPHA   0
#define USE_ALPHA  1
#define MAKE_ALPHA 2

/* for the flipxy parameter in Load(char *fn, ...) */
#define NO_FLIP 0x00
#define FLIP_X  0x01
#define FLIP_Y  0x02

class Texture {
private:
    Display *disp;
    ImlibData *id;
    ImlibImage *im;
    unsigned int tnr[2];
    int x_size, y_size;
    int loaded, masked;
    unsigned char *data;

    int LoadAndConvert(char *fpic, int trans, int flipxy);
public:
    Texture();
    ~Texture();

    int Load(char *fpic, int alpha, int flipxy);
    int Load(char *fpic, char *fmask, int alpha, int flipxy);
    int Load(unsigned char *new_data, int alpha, int width, int height);
    int GetID();
    void Select();
    void SelectMask();
};


#endif
