#include "sea.h"

Sea::Sea()
{
    water = new Texture;
    water->Load(SEA_PIC, NO_ALPHA, FLIP_Y);

    /* create water with texture coords */
    s = 0.0;
    tc_x[0] = sin(s)/(2.0*M_PI);
    tc_x[1] = sin(s+M_PI)/(2.0*M_PI);
    /* front water */
    places[ 0].x =  -6.0;	places[ 0].y = -7.0;
    places[ 1].x =  -2.0;	places[ 1].y = -7.0;
    places[ 2].x =   2.0;	places[ 2].y = -7.0;
    places[ 3].x =   6.0;	places[ 3].y = -7.0;
    /* in between water */
    places[ 4].x = -10.0;	places[ 4].y =  1.0;
    places[ 5].x =  10.0;	places[ 5].y =  1.0;
    places[ 6].x =  -6.0;	places[ 6].y =  1.0;
    places[ 7].x =   6.0;	places[ 7].y =  1.0;
    /* invert sinus */
    places[ 8].x =  -6.0;	places[ 8].y = -3.0;
    places[ 9].x =   6.0;	places[ 9].y = -3.0;
    /* far water */
    places[10].x = -10.0;	places[10].y =  5.0;
    places[11].x =  -6.0;	places[11].y =  5.0;
    places[12].x =  -2.0;	places[12].y =  5.0;
    places[13].x =   2.0;	places[13].y =  5.0;
    places[14].x =   6.0;	places[14].y =  5.0;
    places[15].x =  10.0;	places[15].y =  5.0;
}

Sea::~Sea()
{
    delete water;
}

void Sea::Calc()
{
    /* calc new texture coords */
    s += 0.008;
    tc_x[0] = sin(s)/(2.0*M_PI);
    tc_x[1] = sin(s+M_PI)/(2.0*M_PI);
}

void Sea::Draw()
{
    /* Draw the sea */
    glPushMatrix();
    glRotatef(-90.0, 1.0, 0.0, 0.0);
    water->Select();
    for (int i=0; i<8; i++)
    {
        glPushMatrix();
        glTranslatef(places[i].x, places[i].y, 0.0);
        glBegin(GL_QUADS);
        glNormal3f(0.0, 0.0, 1.0);
        glTexCoord2f(tc_x[0], 0.0);	glVertex3f(-2.0, -2.0, -2.52);
        glTexCoord2f(1.0+tc_x[0], 0.0);	glVertex3f( 2.0, -2.0, -2.52);
        glTexCoord2f(1.0+tc_x[1], 1.0);	glVertex3f( 2.0,  2.0, -2.52);
        glTexCoord2f(tc_x[1], 1.0);	glVertex3f(-2.0,  2.0, -2.52);
        glEnd();
        glPopMatrix();
    }
    for (int i=8; i<16; i++)
    {
        glPushMatrix();
        glTranslatef(places[i].x, places[i].y, 0.0);
        glBegin(GL_QUADS);
        glNormal3f(0.0, 0.0, 1.0);
        glTexCoord2f(tc_x[1], 0.0);	glVertex3f(-2.0, -2.0, -2.52);
        glTexCoord2f(1.0+tc_x[1], 0.0);	glVertex3f( 2.0, -2.0, -2.52);
        glTexCoord2f(1.0+tc_x[0], 1.0);	glVertex3f( 2.0,  2.0, -2.52);
        glTexCoord2f(tc_x[0], 1.0);	glVertex3f(-2.0,  2.0, -2.52);
        glEnd();
        glPopMatrix();
    }
    glPopMatrix();
}
